/*
 * (Hardware-)Address-Resolution-Protocol
 *
 * -
 * Copyright (C) 2001 Cyrus Patel <cyp@fb14.uni-mainz.de>.  
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notices, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must acknowledge providence.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * --Copyright--
 *
 *    $Id: arp.h,v 1.1 2001/05/07 11:17:21 cyp Exp $
*/
#ifndef __KERN_ARP_H
#define __KERN_ARP_H(x) __tkern_ ## x

/* ARP/REVARP is in both layer 3 and layer 2 (or somewhere in between) */
#if (defined(__OSILAYER__) && (__OSILAYER__ == 2 || __OSILAYER__ == 3))

#define _arp_add_gateway       __KERN_ARP_H(arp_add_gateway)
#define _arp_add_entry         __KERN_ARP_H(arp_add_entry)
#define _arp_find_entry        __KERN_ARP_H(arp_find_entry)     
#define _arp_del_entry         __KERN_ARP_H(arp_del_entry)
#define _arp_resolve           __KERN_ARP_H(arp_resolve)
#define _rarp_resolve          __KERN_ARP_H(rarp_resolve)
#define _arp_vrfy_addr_change  __KERN_ARP_H(arp_vrfy_addr_change)
#define _arp_record_redirect   __KERN_ARP_H(arp_record_redirect)

extern void _arp_add_gateway     (uint32_t ip, uint32_t net, uint32_t mask);
extern void _arp_add_entry       (uint32_t ip, const void FAR *hwaddr, int expires);
extern int  _arp_find_entry      (uint32_t ip, void FAR *hwaddr, int FAR *expires);
extern int  _arp_del_entry       (uint32_t ip); /* used by BSD ioctl() */
extern int  _arp_resolve         (uint32_t ina, void FAR *hwaddr );
extern int  _rarp_resolve        (const void FAR *hwaddr, uint32_t FAR *ip);
extern int  _arp_vrfy_addr_change(uint32_t ina);
extern int  _arp_record_redirect (uint32_t ina, uint32_t gate_ina, uint32_t sender_ina);

#endif /* __OSILAYER__ 2/3 */
#endif /* __KERN_ARP_H */
