#ifndef __KERN_INADDR_H
#define __KERN_INADDR_H(x) __tkern_ ## x

#define _my_ntoa            __KERN_INADDR_H(ntoa)
#define _my_aton            __KERN_INADDR_H(aton)

extern int         _my_aton (const char *str, uint32_t *result);
extern const char *_my_ntoa (uint32_t ina, char *buf, unsigned int buflen);

#define is_local_addr       __KERN_INADDR_H(is_local_addr)
#define is_multicast        __KERN_INADDR_H(is_multicast)
#define is_broadcast        __KERN_INADDR_H(is_broadcast)
#define is_onmysubnet       __KERN_INADDR_H(is_onmysubnet)

extern int   is_local_addr  (uint32_t ip);
extern int   is_multicast   (uint32_t ip);
extern int   is_broadcast   (uint32_t ip);
extern int   is_onmysubnet  (uint32_t ip);

#endif /* __KERN_INADDR_H */
