/*
 * Compute internet checksum on one or two data buffers.
 * 1's complement (~) is done by caller.
*/
#include "target.h"   /* FAR */
#include "inchksum.h"

/* ====================================================================== */
/*                         Watcom C 16bit inline asm                      */
/* ====================================================================== */

#if defined(__WATCOMC__) && !defined(__386__)
#pragma off(check_stack)
unsigned long __raw_checksum(const void _far *ptr, unsigned int len);
#pragma aux __raw_checksum = ""                \
                         "push ds            " \
                         "push si            " \
                         "push di            " \
                         "                   " \
                         "mov  ds,dx         " \
                         "mov  si,ax         " \
                         "mov  cx,bx         " \
                         "cld                " \
                         "                   " \
                         "xor  bx,bx         " \
                         "xor  dx,dx         " \
                         "xor  di,di         " \
                         "                   " \
                         "jmp  short __l48_end" \
                         "__l48_top:         " \
                         "sub  cx,48         " \
                         "" /* lodsw; add bx,ax; adc dx,di */ \
                         "" /* alt ops: db 0adh, 03h, 0d8h, 13h, 0d7h */\
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  1 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  2 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  3 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  4 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  5 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  6 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  7 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  8 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  9 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 10 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 11 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 12 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 13 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 14 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 15 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 16 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 17 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 18 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 19 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 20 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 21 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 22 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 23 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 24 */ \
                         "__l48_end:         " \
                         "cmp  cx,48         " \
                         "jae  __l48_top     " \
                         "                   " \
                         "cmp  cx,32         " \
                         "jb __lt_32         " \
                         "sub  cx,32         " \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  1 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  2 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  3 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  4 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  5 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  6 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  7 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  8 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  9 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 10 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 11 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 12 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 13 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 14 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 15 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /* 16 */ \
                         "__lt_32:           " \
                         "                   " \
                         "cmp  cx,16         " \
                         "jb   __lt_16       " \
                         "sub  cx,16         " \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  1 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  2 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  3 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  4 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  5 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  6 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  7 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  8 */ \
                         "__lt_16:           " \
                         "                   " \
                         "cmp  cx,8          " \
                         "jb   __lt_8        " \
                         "sub  cx,8          " \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  1 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  2 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  3 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  4 */ \
                         "__lt_8:            " \
                         "                   " \
                         "cmp  cx,4          " \
                         "jb   __lt_4        " \
                         "sub  cx,4          " \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  1 */ \
                         "db 0adh, 01h, 0c3h, 11h, 0fah" /*  2 */ \
                         "__lt_4:            " \
                         "                   " \
                         "jmp short __l2_end " \
                         "__l2_top:          " \
                         "dec  cx            " \
                         "dec  cx            " \
                         "lodsw              " \
                         "add  bx,ax         " \
                         "adc  dx,di         " \
                         "__l2_end:          " \
                         "cmp  cx,2          " \
                         "jae  __l2_top      " \
                         "                   " \
                         "cmp  cx,1          " \
                         "jb   __lt_1        " \
                         "xor  ax,ax         " \
                         "lodsb              " \
                         "add  bx,ax         " \
                         "adc  dx,di         " \
                         "dec  cx            " \
                         "__lt_1:            " \
                         "                   " \
                         "mov  ax, bx        " \
                         "                   " \
                         "pop  di            " \
                         "pop  si            " \
                         "pop  ds            " \
                         parm [ax dx] [bx] \
                         value [dx ax]         \
                         modify exact [ax bx cx dx];
static unsigned long __raw_checksum (const void FAR *ptr, unsigned int len)
{
  return __raw_checksum( ptr, len );
}
#define HAVE_CHECKSUM_ASM
#endif

/* ====================================================================== */
/*                         TurboC/BorlandC 16bit asm                      */
/* ====================================================================== */

#if (defined(__TURBOC__) || defined(__BORLANDC__)) && !defined(__FLAT__)
static __cdecl unsigned long __raw_checksum (const void _far *data, 
                                             unsigned int len )
{
  unsigned long sum = 0;

  __asm push ds
  __asm push si
  __asm push di

  __asm lds  si,data
  __asm mov  cx,len
  __asm cld

  __asm xor  di,di
  __asm xor  bx,bx
  __asm xor  dx,dx

  __asm jmp short __l48_end
  __l48_top:
  __asm sub  cx,48
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  1 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  2 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  3 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  4 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  5 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  6 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  7 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  8 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  9 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 10 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 11 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 12 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 13 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 14 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 15 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 16 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 17 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 18 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 19 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 20 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 21 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 22 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 23 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 24 */
  __l48_end:
  __asm cmp  cx,48
  __asm jae  __l48_top

  __asm cmp  cx,32
  __asm jb __lt_32
  __asm sub  cx,32
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  1 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  2 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  3 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  4 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  5 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  6 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  7 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  8 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  9 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 10 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 11 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 12 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 13 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 14 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 15 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /* 16 */
  __lt_32:

  __asm cmp  cx,16
  __asm jb   __lt_16
  __asm sub  cx,16
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  1 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  2 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  3 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  4 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  5 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  6 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  7 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  8 */
  __lt_16:

  __asm cmp  cx,8
  __asm jb   __lt_8
  __asm sub  cx,8
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  1 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  2 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  3 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  4 */
  __lt_8:

  __asm cmp  cx,4
  __asm jb   __lt_4
  __asm sub  cx,4
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  1 */
  __asm db 0adh, 01h, 0c3h, 11h, 0fah  /*  2 */
  __lt_4:

  __asm jmp short __l2_end
  __l2_top:
  __asm dec  cx
  __asm dec  cx
  __asm lodsw
  __asm add  bx,ax
  __asm adc  dx,di
  __l2_end:
  __asm cmp  cx,2
  __asm jae  __l2_top

  __asm cmp  cx,1
  __asm jb   __lt_1
  __asm xor  ax,ax
  __asm lodsb
  __asm add  bx,ax
  __asm adc  dx,di
  __asm dec  cx
  __lt_1:

  __asm pop  di
  __asm pop  si
  __asm pop  ds

  __asm mov  ax, bx
  __asm lea  bx,sum
  __asm mov  ss:[bx+0],ax
  __asm mov  ss:[bx+2],dx
  
  return sum;
}
#define HAVE_CHECKSUM_ASM
#endif

/* ====================================================================== */
/*                               C version                                */
/* ====================================================================== */

#if !defined(HAVE_CHECKSUM_ASM)
static unsigned long __raw_checksum (const void FAR *ptr, unsigned int len)
{
  register const unsigned short FAR *w = (const unsigned short FAR *)ptr;
  register unsigned int nleft = len;
  register unsigned long sum = 0;

  /* Of all the DOS compilers, only BCC/TC generates truly poor code -
   * everything is off the stack (and 'ptr' is es: addressed!). The 
   * other compilers are purty good. Code generated for pmode/386 takes
   * a penalty though because the load instructions are all 0fh prefixed.
   * This (and alignment of 'w' - which isn't often necessary) is all 
   * that would make 386 asm code worthwhile.
  */
  while (nleft > 32)
  {
    sum += w[ 0]; sum += w[ 1]; sum += w[ 2]; sum += w[ 3]; 
    sum += w[ 4]; sum += w[ 5]; sum += w[ 6]; sum += w[ 7]; 
    sum += w[ 8]; sum += w[ 9]; sum += w[10]; sum += w[11]; 
    sum += w[12]; sum += w[13]; sum += w[14]; sum += w[15];
    w += 16;
    nleft -= 32;
  }

  while (nleft > 8)
  {
    sum += w[ 0]; sum += w[ 1]; sum += w[ 2]; sum += w[ 3]; 
    w += 4;
    nleft -= 8;
  }

  while (nleft > 1) 
  {
    sum += *w++;
    nleft -= 2;
  }

  /* mop up an odd byte, if necessary */
  if (nleft == 1) 
  {
    union {
      unsigned short us;
      unsigned char uc[2];
    } last;
    last.uc[0] = *(const unsigned char *)w;
    last.uc[1] = 0;
    sum += last.us;
  }

  return sum;
}
#endif

/* ====================================================================== */
/*                          callable functions                            */
/* ====================================================================== */

unsigned short checksum2( const void FAR *ptr1, unsigned int len1,
                          const void FAR *ptr2, unsigned int len2 )
{
  unsigned long sum = 0;

  /*
   * Our algorithm is simple, using a 32 bit accumulator (sum), we add
   * sequential 16 bit words to it, and at the end, fold back all the
   * carry bits from the top 16 bits into the lower 16 bits.
  */

  /* KMSG((0,"ptr1 = %p, len = %u\n", ptr1, len1 )); */
  if (len2)
  {
    sum = __raw_checksum( ptr1, len1 & ~1u );
    /* KMSG((0,"sum1 = %lu\n", sum )); */

    if (len1 & 1)
    {
      union {
        unsigned short us;
        unsigned char uc[2];
      } last;
      last.uc[0] = *(((const unsigned char FAR *)ptr1) + (len1 - 1));
      last.uc[1] = *((const unsigned char FAR *)ptr2);
      sum += last.us;
      ptr2 = (const void *)(((const unsigned char FAR *)ptr2) + 1);
      len2--;
    }

    ptr1 = ptr2;
    len1 = len2;
    /* KMSG((0,"ptr2 = %p, len = %u\n", ptr1, len1 )); */
  }

  sum += __raw_checksum( ptr1, len1 );
  /* KMSG((0,"sum2 = %lu\n", sum )); */

  /* add back carry outs from top 16 bits to low 16 bits */
  sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
  sum += (sum >> 16);			/* add carry */

  return (unsigned short)sum;           /* truncate to 16 bits */
                                        /* ones-complement is done by caller */
}  

unsigned short inchksum( const void FAR *ptr, unsigned int len )
{
  /* KMSG((WDLEV_TRACE,"begin __raw checksum\n")); */
  unsigned long sum = __raw_checksum( ptr, len );
  /* KMSG((WDLEV_TRACE,"end __raw checksum\n")); */

  /* add back carry outs from top 16 bits to low 16 bits */
  sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
  sum += (sum >> 16);			/* add carry */

  return (unsigned short)sum;           /* truncate to 16 bits */
                                        /* ones-complement is done by caller */
}

