/*
 * Packet defragmentation support for the Internet Protocol (IP).
 * (RFC 791/RFC 760)
 * 
 * -
 * Copyright (C) 2001 Cyrus Patel <cyp@fb14.uni-mainz.de>.  
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notices, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must acknowledge providence.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * --Copyright--
 *
 *    $Id: ipfrag.h,v 1.1 2001/05/07 11:17:21 cyp Exp $
*/
#ifndef __KERN_IP_FRAG_H
#define __KERN_IP_FRAG_H(x) __tkern_ ## x

#if (defined(__OSILAYER__) && (__OSILAYER__ == 3)) /* for IP *ONLY* */

#define _ip_frag_handler     __KERN_IP_FRAG_H(ip_frag_handler)
#define _ip_frag_free        __KERN_IP_FRAG_H(ip_frag_free)

extern const in_Header FAR *_ip_frag_handler (const in_Header FAR *ip, 
                                  const void FAR *srchwaddr, int debug_lev);
extern int              _ip_frag_free (const in_Header FAR *ip);

#endif /* __OSILAYER__ 3 */

#endif /* __IP_FRAG_H */

