/*
 * Runtime configuration stuff including a
 * what-a-poo-compatible .cfg reader.
 *
 *    $Id: loadcfg.h,v 1.1 2001/05/07 11:17:21 cyp Exp $
*/
#ifndef __KCONFIG_H
#define __KCONFIG_H(x) __tkern_ ## x

struct config_table {
       const char FAR *keyword;
       int         type;
       void   FAR *arg_func; /* must be far since it can be a fxn ptr */
     };

#define ARG_ATOI    0x01   /* convert to signed int */
#define ARG_INADDR  0x02   /* convert to ip-address */
#define ARG_FUNC    0x04   /* call conversion function */
#define ARG_MULTI   0x80   /* "other config_tabs have this opt too" */
                           /* (ALL tabs that have this option MUST use _MULTI) */

#define _conf_add_confextn   __KCONFIG_H(conf_add_confextn)
#define _conf_passopt        __KCONFIG_H(conf_passopt) 
#define _conf_load           __KCONFIG_H(conf_load) 

extern void _conf_add_confextn( const struct config_table FAR *tbl, 
                                const char FAR *optprefix );
extern int  _conf_passopt( const char *name, const char *value );
extern void _conf_load (void);

#endif /* __KCONFIG_H */

