/*
 * Monotonic time source.
 *
 * -
 * Copyright (C) 2001 Cyrus Patel <cyp@fb14.uni-mainz.de>.  
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notices, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must acknowledge providence.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * --Copyright--
 *
 *    $Id: timer.h,v 1.1 2001/05/07 11:17:21 cyp Exp $
*/
#ifndef __KERN_TIMER_H
#define __KERN_TIMER_H(x) __tkern_ ## x

#define timer_tick_count  __KERN_TIMER_H(timer_tick_count)
#define timer_hsec_count  __KERN_TIMER_H(timer_hsec_count)
#define timer_msec_count  __KERN_TIMER_H(timer_msec_count)
#define timer_sec_count   __KERN_TIMER_H(timer_sec_count)

extern unsigned long timer_tick_count(void);  /* max 4 years */
extern unsigned long timer_sec_count(void);   /* max ~49710.2 days */
extern unsigned long timer_hsec_count(void);  /* max ~497.1 days */
extern unsigned long timer_msec_count(void);  /* max ~49.7 days */
extern unsigned int  timer_msec_tres(void);   /* timer resolution in msecs */

/* --------------------------------------------------------------------- */ 

#define Random        __KERN_TIMER_H(Random)
extern unsigned long  Random(unsigned long a, unsigned long b);

/* ---------------------------------------------------------------------- */

#define timer_syst_enter  __KERN_TIMER_H(timer_syst_enter)
#define timer_syst_exit   __KERN_TIMER_H(timer_syst_exit) 
#define timer_syst_read   __KERN_TIMER_H(timer_syst_read) 
#define timer_usrt_read   __KERN_TIMER_H(timer_usrt_enter)

extern void timer_syst_enter (void);
extern void timer_syst_exit (void);
extern unsigned long timer_syst_read (unsigned long *secsP, unsigned int *msecsP);
extern unsigned long timer_usrt_read (unsigned long *secs, unsigned int *msecs);

#endif /* __KERN_TIMER_H */
