/*
 * -
 * Copyright (C) 2001 Cyrus Patel <cyp@fb14.uni-mainz.de>.  
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notices, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must acknowledge providence.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * --Copyright--
 *
 *    $Id: utsio.h,v 1.1 2001/05/07 11:17:21 cyp Exp $
*/
#ifndef __USOCKIO_H
#define __USOCKIO_H(x) __tkern_ ## x

/* may only be included by modules that export a TPI */
#if (defined(__COMPILING_SOCKIO__) ||                /* consumer */ \
     (defined(__OSILAYER__) && (__OSILAYER__ == 4))) /* producer */

struct sockio_info
{
  const struct wso_usrreq_tab FAR *dispatch; /* also serves as magic */
  void FAR *pcb;                             /* proto's stuff */
};

struct wso_usrreq_tab 
{
  int ip_proto;

  int (*so_create)(struct sockio_info *s);
  int (*so_bind)(struct sockio_info *s, const uint32_t *laddr, const uint16_t *lport);
  int (*so_connect)(struct sockio_info *s, const uint32_t *raddr, const uint16_t *rport);
  int (*so_listen)(struct sockio_info *s, int qlen);
  int (*so_accept)(struct sockio_info *s, struct sockio_info *news,
                   uint32_t *raddr, uint16_t *rport);
  int (*so_shutdown)(struct sockio_info *s, int how);
  int (*so_destroy)(struct sockio_info *s); 
  int (*so_recv)(struct sockio_info *s, void *buf, unsigned int buflen,
                  int flags, uint32_t *src_ip, uint16_t *src_port );
  int (*so_send)(struct sockio_info *s, const void *buf, unsigned int buflen,
                  int flags, const uint32_t *dest_ip, const uint16_t *dest_port);
  int (*so_poll)(struct sockio_info *s, int events, unsigned long timeout);
  int (*so_gssockopt)(struct sockio_info *s, unsigned long opt, const int *newval, int *oldval);

  /* the so_listen_wcompat function must ALWAYS be the
  * last in the table (its a quick and easy way to check that all
  * protos initializate their tables correctly). 
  */
  int (*so_listen_wcompat)(struct sockio_info *s, uint16_t lport, uint32_t raddr, uint16_t rport);
};

#define _wsio_register_dispatch __USOCKIO_H(wsio_register_dispatch)
extern int _wsio_register_dispatch(const struct wso_usrreq_tab FAR *ur);

#endif /* __OSILAYER__ 4 */
#endif /* ifndef __USOCKIO_H */
